import java.io.*;

/**ElevenDollar.java

 */
/*current holes:
  The nickname and password are still useless in P3...  They mostly exist to
    justify Person, and provide extensibility in P4.
  Last Modified isn't implemented
    Have this be stored into Person?
    Compare timestamps every time.  Warn user if local doesn't match remote
    get last trasactions.  "SecurePerson" class?
    
  Last Buddy-Viewed-modifiedmaybe?

  With a Buddy, get other person's transfers and balance

Extend person to Buddy class?  and SecurePerson class?
  
  Clean up debug prints in ElevenClient

Other possibilities
  Let students request money given other student's passwords?
   Write the driver for them?
    Grading P3
    For future P4
       check if transfer > acct balance
       buddy list
          use "finger" and "write" shell commands to chat?
          "where buddy is in lab" reverse dns lookup?
       error checks
          transfer more than have
          transfer negative amount
          tabs in username/pwd
       ElevenVendor maybe?
          a different client--holds a price and comment, 
                              takes a login and password in a loop
                              uses a different transaction
	  how to get password without showing input?
	
      templates?

      Fred owes me .02 =)
TODO:
  Serilizable input output stream
*/
import java.text.NumberFormat;
import java.util.Locale;

public class ElevenDollar {

    public static void printMenu() {
	System.out.println("Welcome to the 11-dollar banking system");
	System.out.println("A)Retrieve personal information");
	System.out.println("B)Update your personal information");
	System.out.println("C)Check your balance");
	System.out.println("D)Transfer money to another account");
	System.out.println("E)Check your transaction history");
	System.out.println("X)Exit");
    }

  public static void main(String args[]) throws IOException {
      
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    Account myAccount = new Account();
    myAccount.getInformation();

    String inputs;
    char inputc = 0;
    do {
      printMenu();
      inputs = in.readLine();
      if(inputs==null) break;
      if(inputs.equals("")) continue;
      inputc = inputs.charAt(0);

      switch (inputc) {
      case 'A':
      case 'a':
	System.out.println("Which account?(Leave blank to retrieve your own)");
	String userToGet = in.readLine();
	if (userToGet.equals("")) {
	  System.out.println(myAccount.getInformation());
	} else {
	  System.out.println(myAccount.getInformation(userToGet));
	}
	break;
      case 'B':
      case 'b':
	Person temp = myAccount.getPerson();
	System.out.println("New Nickname?(default:"+ temp.getNickname() + ")");
	String newNick = in.readLine();
	if (!(newNick.equals(""))) {
	  temp.setNickname(newNick);
	}
	System.out.println("New Password?(default:" + temp.getPassword() + ")");
	String newPass = in.readLine();
	if (!(newPass.equals(""))) {
	  temp.setPassword(newPass);
	}
	System.out.println(myAccount.updateInformation());
	break;
      case 'C':
      case 'c':
	double balance = myAccount.checkBalance();
	if (balance == -1) System.out.println("ERROR");
	NumberFormat dollarFormat = NumberFormat.getCurrencyInstance(Locale.US);
	System.out.println("You have " + dollarFormat.format(balance));
	break;
      case 'D':
      case 'd':
	System.out.println("To which account will you transfer?");
	String user = in.readLine();
	System.out.println("How much money?");
	double amt = Double.parseDouble(in.readLine());
	System.out.println("Optional comment?");
	String comment = in.readLine();
	System.out.println(myAccount.transferToAcct(user, amt, comment));
	break;
      case 'E':
      case 'e':
	System.out.println(myAccount.getHistory());
	break;
      }
    } while ((inputc != 'X') && (inputc != 'x'));
  }
}
